<?php
/**
 * SearchSuggest extension - a search extension utilizing
 * MediaWiki's built-in Ajax functions
 *
 * @author Adam Meyer
 * @copyright © 2008 Adam Meyer
 */
//See below under "function wfAjaxSearchSuggest" for configuration
 
if( !defined( 'MEDIAWIKI' ) ) {
	echo( "This file is part of an extension to the MediaWiki software and cannot be used standalone.\n" );
	die( 1 );
}
 
$wgExtensionFunctions[] = 'wfAjaxSearch';
$wgAjaxExportList[] = 'wfAjaxSearchSuggest';
$wgHooks['OutputPageBeforeHTML'][] = 'wfAjaxSearchSuggestHeaders';
 
$wgExtensionCredits['other'][] = array(
    'name' => 'SearchSuggest',
    'author' => 'Adam Meyer',
    'version' => '0.2',
    'url' => 'http://www.mediawiki.org/wiki/Extension:Search_Suggest',
    'description' => 'Ajax-based Search Suggest that places results below search bar.',
);
 
function wfAjaxSearch() {
	global $wgUseAjax;
	if (!$wgUseAjax) {
		wfDebug('wfAjaxSearch: $wgUseAjax is not enabled, aborting extension setup.');
		return;
	}
}
 
function wfAjaxSearchSuggest( $term ) {
 
	//configure the following to change settings
	$limit = 8; //number of results to spit back
	$location = 1; //set to 1 to search anywhere in the article name, set to 0 to search only at the begining
 
 
	global $wgContLang, $wgOut;
	$response = new AjaxResponse();
	$db = wfGetDB( DB_SLAVE );
	$l = new Linker;
 
       	$term = str_replace(' ', '_', $term);
 
	if($location == 1){
 
		$res = $db->select( 'page', 'page_title',
				array(  'page_namespace' => 0,
					"UPPER(CAST(page_title AS CHAR)) LIKE '%" .$db->strencode( $wgContLang->uc ($term)). "%'" ),
					"wfSajaxSearch",
					array( 'LIMIT' => $limit )
				);
	} else {		
 
		$res = $db->select( 'page', 'page_title',
			array(  'page_namespace' => 0,
				"UPPER(CAST(page_title AS CHAR)) LIKE '". $db->strencode( $wgContLang->uc ($term)) ."%'" ),
				"wfSajaxSearch",
				array( 'LIMIT' => $limit )
			);		
	}
 
	$r = "";	
	while ($row = $db->fetchObject( $res ) ){
		$nt = Title::newFromDBkey( $row->page_title );		
		$r .= '<li>' . $l->makeKnownLinkObj( $nt ) . "</li>\n";
 
	}
	$html ='<ul>' .$r .'</ul>';
 
	return $html;
}
 
function wfAjaxSearchSuggestHeaders(){
	global $wgOut;
	wfAjaxSetSearchSuggestHeaders($wgOut);
	return false;
}
 
 
function wfAjaxSetSearchSuggestHeaders($outputPage) {
	global $wgJsMimeType, $wgStylePath, $wgScriptPath;
	$outputPage->addLink( 
		array( 
			'rel' => 'stylesheet', 
			'type' => 'text/css', 
			'href' => $wgScriptPath.'/extensions/SearchSuggest/SearchSuggest.css' 
		) 
	);
	$outputPage->addScript( "<script type=\"{$wgJsMimeType}\" src=\"$wgScriptPath/extensions/SearchSuggest/SearchSuggest.js\">"."</script>\n");
	$outputPage->addScript( "<script type=\"{$wgJsMimeType}\">hookEvent(\"load\", ss_ajax_onload);</script>\n" );
}

